#pragma once
#include <iostream>
#include <stdlib.h>
#include <string>
#include <fstream>
#include <vector>
#include <algorithm>
#include <iterator>
#include "funcRealization.h"

// 1.	Функция createData(), создающая текстовый файл с данными в виде 100 случайно сгенерированных целых чисел в диапазоне от –50 до 50. Предусмотреть следующие версии данной функции:
//1.1.	Функция, выгружающая данные с использованием файловых потоков.
void create_data_using_file_stream(){
    std::ofstream file("file.txt");
    srand(time(nullptr));
    if (!file.is_open())
        std::cout << "Error";
    else {
        for (int i = 0; i < 100; i++){
            file <<  rand() % 101 - 50 << " ";
        }
    }
    file.close();
}

// 1.2.	Функция, использующая алгоритм generate для инициализации вспомогательного контейнера и алгоритм copy
// для вывода его содержимого в файл с использованием потоковых итераторов.
void create_data_using_generate(){
    std::vector<int> vec(100);
    std::ofstream file("file.txt");
    srand(time(nullptr));
    if (!file.is_open())
        std::cout << "Error";
    else {
        std::generate(vec.begin(), vec.end(), [](){return rand() % 101 - 50;});
        std::copy(vec.begin(), vec.end(), std::ostream_iterator<int>(file, " "));
    }
file.close();
}

//2.	Шаблонная функция loadData(), загружающая данные в последовательный контейнер данного типа.
// Предусмотреть следующие версии данной функции:
//2.1.	Функция, загружающая данные с использованием файловых потоков.
template <typename T>
void load_data_using_file_stream(T& cont){
    std::ifstream file("file.txt");
    if (!file.is_open())
        std::cout << "Error";
    else {
        int cur;
        while (file >> cur){
            cont.push_back(cur);
        }
    }
    file.close();
}

//2.2.	Функция, загружающая данные с использованием потоковых итераторов и алгоритма copy.
template <typename T>
void loaddata_using_copy_and_iterator(T& cont){
    std::ifstream file("file.txt");
    if (!file.is_open())
        std::cout << "Error";
    else {
        std::copy(std::istream_iterator<int>(file), std::istream_iterator<int>(), back_inserter(cont));
    }
file.close();
}

//3.	Функция modify(), модифицирующая загруженные данные
// добавить к каждому числу половину последнего отрицательного числа
template <typename T>
void modify(T& cont){
    auto last_neg = (*std::find_if(cont.crbegin(), cont.crend(), [](auto value){ return (value < 0);}))/2;
    std::for_each(cont.begin(), cont.end(), [last_neg](auto &value){ value += last_neg;});
}

// Предусмотреть следующие версии функции Modify():
// 3.1.	Как шаблонная функция, принимающая последовательный контейнер данного типа.
// Должна добавлять в конец контейнера результата сумму и среднее арифметическое элементов контейнера по абсолютной величине.
template <typename T>
void modify_container_getter(T& cont){
    int sum = 0;
    auto last_neg = (*std::find_if(cont.crbegin(), cont.crend(), [](auto value){ return (value < 0);}))/2;
    std::for_each(cont.begin(), cont.end(), [&sum, last_neg](auto &value){ value += last_neg;
        sum += value;});
    cont.push_back(abs(sum));
    cont.push_back(abs(sum / 100));
}

//3.2.	Как функция, принимающая аргументы-итераторы.
template <typename T>
void modify_args_iters(T Iter_beg, T Iter_end){
    auto last_neg = (*std::find_if(Iter_beg, Iter_end, [](auto value){ return (value < 0);}))/2;
    std::for_each(Iter_beg, Iter_end, [last_neg](auto &value){ value += last_neg;});
}

//3.3.	Как функция, использующая алгоритм for_each().
// Конкретную операцию передавать в виде функционального объекта или лямбда-функции.

//Илья Олегович, я сделала через эту штуку до этого.. решила не переписывать, но через цикл фор я модифай тоже могу реализовать!!!!!!!

//3.4.	Как функция, использующая алгоритм transform() и потоковые итераторы для одновременного считывая данных из файла,
// их преобразования и вывода в файл результата.
void modify_transform(std::ifstream& buffer) {
    std::vector<int> cont(100);
    if (!buffer.is_open()) {
        std::cout << "Error";
    }
    std::copy(std::istream_iterator<int>(buffer), std::istream_iterator<int>(), cont.begin());
    auto last_neg = (*std::find_if(cont.crbegin(), cont.crend(), [](auto value){ return (value < 0);}))/2;
    std::ofstream fout("file.txt");
    std::transform(cont.begin(), cont.end(), std::ostream_iterator<int>(fout, "\n"), [last_neg](auto& value) {
        return value += last_neg;
    });
}

//4.	Функция outputResult() для вывода контейнера-результата. Предусмотреть следующие версии данной функции:
//4.1.	Функция, выгружающая данные с использованием файловых потоков.
template<typename T>
void output_by_file_stream(T& cont) {
    std::ofstream file("file.txt");
    if (!file.is_open())
        std::cout << "Error";
    else {
        for (auto i = cont.begin(); i < cont.end(); i++) {
            file << *i << " ";
        }
    }
    file.close();
}

//4.2.	Функция, использующая алгоритм copy для вывода контейнера в файл с использованием потоковых итераторов.
template<typename T>
void output_using_copy(T& cont) {
    std::ofstream file("file.txt");
    if (!file.is_open())
        std::cout << "Error";
    else {
        copy(cont.begin(), cont.end(), std::ostream_iterator<int>(file, " "));
    }
    file.close();
}